/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-31 at 17:16:32 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.discovery.model;

/**
 * Model definition for RestResource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the APIs Discovery Service. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RestResource extends com.google.api.client.json.GenericJson {

  /**
   * Methods on this resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, RestMethod> methods;

  static {
    // hack to force ProGuard to consider RestMethod used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(RestMethod.class);
  }

  /**
   * Sub-resources on this resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, RestResource> resources;

  /**
   * Methods on this resource.
   * @return value or {@code null} for none
   */
  public java.util.Map<String, RestMethod> getMethods() {
    return methods;
  }

  /**
   * Methods on this resource.
   * @param methods methods or {@code null} for none
   */
  public RestResource setMethods(java.util.Map<String, RestMethod> methods) {
    this.methods = methods;
    return this;
  }

  /**
   * Sub-resources on this resource.
   * @return value or {@code null} for none
   */
  public java.util.Map<String, RestResource> getResources() {
    return resources;
  }

  /**
   * Sub-resources on this resource.
   * @param resources resources or {@code null} for none
   */
  public RestResource setResources(java.util.Map<String, RestResource> resources) {
    this.resources = resources;
    return this;
  }

  @Override
  public RestResource set(String fieldName, Object value) {
    return (RestResource) super.set(fieldName, value);
  }

  @Override
  public RestResource clone() {
    return (RestResource) super.clone();
  }

}
